package ikalaskuri;

import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.util.*;

/**
 * Title:        Iklaskuri
 * Description:  Web-sivuille tehty appletti, jolla sivustoni kyttjt voivat laskea ikns piviss. Edist yli 10000 pivn ikisille tarkoitetun ryppyvoiteen myynti.
 * Copyright:    Copyright (c) 2001
 * Company:      SuloSoft Ky
 * @author Sulo Surffaaja
 * @version 1.0
 */

public class WebLaskin extends Applet {
  boolean isStandalone = false;
  GridLayout Pystyjako = new GridLayout();
  Panel Tulospaneeli = new Panel();
  Panel Syottopaneeli = new Panel();
  Panel Nappipaneeli = new Panel();
  Label TulosTeksti = new Label();
  TextField PaivaKentta = new TextField();
  TextField KuukausiKentta = new TextField();
  TextField VuosiKentta = new TextField();
  Label Piste1 = new Label();
  Label Piste2 = new Label();
  Button LaskeNappi = new Button();
  /**Get a parameter value*/
  public String getParameter(String key, String def) {
    return isStandalone ? System.getProperty(key, def) :
      (getParameter(key) != null ? getParameter(key) : def);
  }
  /**Construct the applet*/
  public WebLaskin() {
  }
  /**Initialize the applet*/
  public void init() {
    try {
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }
  /**Component initialization*/
  private void jbInit() throws Exception {
    Pystyjako.setRows(3);
    this.setLayout(Pystyjako);
    TulosTeksti.setFont(new java.awt.Font("SansSerif", 0, 22));
    TulosTeksti.setText("Syt iksi!");
    PaivaKentta.setColumns(2);
    KuukausiKentta.setColumns(2);
    VuosiKentta.setColumns(4);
    Piste1.setText(".");
    Piste2.setText(".");
    LaskeNappi.setLabel("Laske!");
    LaskeNappi.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        LaskeNappi_actionPerformed(e);
      }
    });
    this.add(Tulospaneeli, null);
    Tulospaneeli.add(TulosTeksti, null);
    this.add(Syottopaneeli, null);
    Syottopaneeli.add(PaivaKentta, null);
    Syottopaneeli.add(Piste1, null);
    Syottopaneeli.add(KuukausiKentta, null);
    Syottopaneeli.add(Piste2, null);
    Syottopaneeli.add(VuosiKentta, null);
    this.add(Nappipaneeli, null);
    Nappipaneeli.add(LaskeNappi, null);
  }
  /**Start the applet*/
  public void start() {
  }
  /**Stop the applet*/
  public void stop() {
  }
  /**Destroy the applet*/
  public void destroy() {
  }
  /**Get Applet information*/
  public String getAppletInfo() {
    return "Applet Information";
  }
  /**Get parameter info*/
  public String[][] getParameterInfo() {
    return null;
  }

  void LaskeNappi_actionPerformed(ActionEvent e) {

      // Muutetaan parametrit numeerisiksi
      int vuosi, kuukausi, paiva;
      try {
          vuosi = Integer.decode(VuosiKentta.getText()).intValue();
          kuukausi = Integer.decode(KuukausiKentta.getText()).intValue();
          paiva = Integer.decode(PaivaKentta.getText()).intValue();
      }
      catch (NumberFormatException poikkeus) {
          // Virheellisi parametrej, eivt muutu merkkijonoiksi!
          TulosTeksti.setText("Virhe!");
          PaivaKentta.requestFocus();
          return;
      }

      // Tarkistetaan pivmrt

      int[] paiviaKuukaudessa = { 31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31 };
      if ((vuosi % 400 == 0) || ((vuosi % 4 == 0) && (vuosi % 100 != 0)))
          paiviaKuukaudessa[1] = 29;
      if (paiva < 1 || kuukausi < 1 || kuukausi > 12 ||
          paiva > paiviaKuukaudessa[kuukausi-1]) {
          // Epkelpo piv
          TulosTeksti.setText("Virhe!");
          PaivaKentta.requestFocus();
          return;
      }

      // Muodostetaan pivmrt
      Date syntymapaiva = new GregorianCalendar(vuosi, kuukausi-1, paiva).getTime();
      Date nyt = new Date();

      long ikaPaivina = (nyt.getTime()-syntymapaiva.getTime())/1000/86400;
      TulosTeksti.setText(ikaPaivina+" piv");
  }
}