package nerdometer;

/**
 * Title:        Nerd-O-Meter
 * Description:  Yksinkertainen nrttitesti, jolla demonstroidaan JBuilderin kytt.
 * Copyright:    Copyright (c) 2001
 * Company:      MikroBitti
 * @author Tarmo Toikkanen
 * @version 1.0
 */

/**
 * Kysymys-luokka sislt yhden Kysymyksen tiedot ja palvelut.
 */
public class Kysymys {
  /**
   * Kysymys merkkijonona.
   */
  private String kysymys;
  /**
   * Vaihtoehdot String-taulukkona. Taulukko luodaan muodostimessa.
   * @see Kysymys#Kysymys
   */
  private String[] vaihtoehdot;
  /**
   * Vaihtoehtojen pistearvot int-taulukkona. Taulukko luodaan muodostimessa.
   */
  private int[] pisteet;
  /**
   * Kyttjn valitseman vaihtoehdon numero (0..3).
   */
  private int vastaus;

  /**
   * Muodostin, jota kutsutaan kun uutta Kysymys-oliota luodaan.
   * @param kysymys Esitettv kysymys merkkijonona.
   * @param vaihtoehtoja Vaihtoehtojen lukumr (yleens 4).
   */
  public Kysymys(String kysymys,int vaihtoehtoja) {
    this.kysymys=kysymys;
    this.vaihtoehdot=new String[vaihtoehtoja];
    this.pisteet=new int[vaihtoehtoja];
  }
  /**
   * Lis uuden vaihtoehdon kysymykselle. Kun Kysymys-olio on luotu, kutsutaan
   * tt metodia kerran jokaista vaihtoehtoa kohti.
   * @param vaihtoehto Vaihtoehdon teksti.
   * @param pisteet Vaihtoehdon pistearvo.
   */
  public void lisaaVaihtoehto(String vaihtoehto,int pisteet) {
    for(int n=0;n<this.vaihtoehdot.length;n++)
      if (this.vaihtoehdot[n]==null) {
        this.vaihtoehdot[n]=vaihtoehto;
        this.pisteet[n]=pisteet;
        return;
      }
  }
  /**
   * Palauttaa kysymystekstin.
   * @return Kysymys String-muodossa.
   */
  public String haeKysymys() { return this.kysymys; }
  /**
   * Palauttaa kysymyksen vaihtoehtojen lukumrn.
   * @return Vastausvaihtoehtojen lukumr kokonaislukuna.
   */
  public int haeVaihtoehtojenMaara() { return this.vaihtoehdot.length; }
  /**
   * Palauttaa tietyn vastausvaihtoehdon tekstin.
   * @param n Halutun vaihtoehdon numero.
   * @return Vaihtoehto String-muodossa.
   */
  public String haeVaihtoehto(int n) { return this.vaihtoehdot[n]; }
  /**
   * Tallentaa kyttjn valitseman vastausvaihtoehdon.
   * @param vastaus Valittu vastausvaihtoehdon numero.
   */
  public void vastaa(int vastaus) { this.vastaus=vastaus; }
  /**
   * Laskee, montako pistett kyttj on tst kysymyksest saanut.
   * @return Kyttjn tallentaman vastauksen pistearvo.
   */
  public int haePisteet() { return this.pisteet[this.vastaus]; }
}