package nerdometer;

import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.net.*;
import java.io.*;
import java.util.Vector;

/**
 * Title:        Nerd-O-Meter
 * Description:  Yksinkertainen nrttitesti, jolla demonstroidaan JBuilderin kytt.
 * Copyright:    Copyright (c) 2001
 * Company:      MikroBitti
 * @author Tarmo Toikkanen
 * @version 1.0
 */

public class NerdOMeter extends Applet {
  /* Tss ovat JBuilderin Applet-velhon ja Designerin kautta luomat
   * muuttujat.
   */
  boolean isStandalone = false;
  String kysymysURL;
  Panel panelValinnat = new Panel();
  Checkbox vast1 = new Checkbox();
  Checkbox vast2 = new Checkbox();
  Checkbox vast3 = new Checkbox();
  Checkbox vast4 = new Checkbox();
  GridLayout gridLayout1 = new GridLayout();
  CheckboxGroup ryhma1 = new CheckboxGroup();
  Label labelKysymys = new Label();
  BorderLayout borderLayout1 = new BorderLayout();
  Button buttonVastaa = new Button();
  Panel panelNapit = new Panel();

  // Tss ovat itse listyt muuttujat
  /** Vakio, joka kertoo kysymysten vastausvaihtoehtojen mrn. */
  public static final int VAIHTOEHTO_MAARA = 4;
  /** Kyttliittymn nelj Checkboxia taulukoituna ksittelyn helpottamiseksi. */
  Checkbox[] vaihtoehdot = new Checkbox[] { vast1,vast2,vast3,vast4 };
  /** Vector (kasvava taulukko), joka sislt kaikki kysymykset. */
  Vector kysymykset = new Vector(); // sislt Kysymys-olioita
  /** Kertoo sen kysymyksen numeron, joka kulloinkin on kyttliittymss nkyviss */
  int naytettyKysymys;

  /**
   * JBuilderin luoma apumetodi, joka hakee sovelmaparametrin nimen perusteella.
   */
  public String getParameter(String key, String def) {
    return isStandalone ? System.getProperty(key, def) :
      (getParameter(key) != null ? getParameter(key) : def);
  }

  /**
   * Tt metodia kutsutaan selaimesta, kun sovelmaa alustetaan.
   * JBuilder tekee metodin valmiiksi ja suorittaa parametrien tulkkauksen
   * sek jbInit-metodin kutsumisen, joka rakentaa kyttliittymn.
   * Loppuun on itse listty yksi rivi.
   */
  public void init() {
    try {
      kysymysURL = this.getParameter("KYSYMYS_URL", "kysym.txt");
    }
    catch(Exception e) {
      e.printStackTrace();
    }
    try {
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
    lataaKysymykset();  // Tm on itse listty: ladataan kysymykset palvelimelta
  }
  /**
   * Tm on JBuilderin luoma metodi. Kaikki Designerissa tehdyt muutokset
   * tallentuvat tmn metodin sisn.
   */
  private void jbInit() throws Exception {
    vast1.setCheckboxGroup(ryhma1);
    vast1.setLabel("Vaihtoehto 1");
    vast2.setCheckboxGroup(ryhma1);
    vast2.setLabel("Vaihtoehto 2");
    vast3.setCheckboxGroup(ryhma1);
    vast3.setLabel("Vaihtoehto 3");
    vast4.setCheckboxGroup(ryhma1);
    vast4.setLabel("Vaihtoehto 4");
    panelValinnat.setLayout(gridLayout1);
    gridLayout1.setRows(4);
    labelKysymys.setFont(new java.awt.Font("Dialog", 1, 16));
    labelKysymys.setText("Kysymys");
    this.setLayout(borderLayout1);
    buttonVastaa.setLabel("Vastaa");
    buttonVastaa.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        buttonVastaa_actionPerformed(e);
      }
    });
    this.add(labelKysymys, BorderLayout.NORTH);
    this.add(panelNapit, BorderLayout.SOUTH);
    panelNapit.add(buttonVastaa, null);
    this.add(panelValinnat, BorderLayout.CENTER);
    panelValinnat.add(vast1, null);
    panelValinnat.add(vast2, null);
    panelValinnat.add(vast3, null);
    panelValinnat.add(vast4, null);
  }
  /**
   * JBuilderin luoma metodi. Jokaisella sovelmalla tulisi olla tm metodi,
   * jossa voidaan palauttaa yleist tietoa sovelmasta. Palautettu merkkijono
   * on itse kirjoitettu.
   */
  public String getAppletInfo() {
    return "Nerd-O-Meter v0.01, copyright 2001 Tarmo Toikkanen";
  }
  /**
   * JBuilderin luoma metodi. Jokaisella sovelmalla tulisi olla tm metodi,
   * jossa voidaan palauttaa kaksiulotteisessa String-taulukossa tiedot
   * sovelman hyvksymist parametreista.
   */
  public String[][] getParameterInfo() {
    String[][] pinfo =
      {
      {"KYSYMYS_URL", "String", "URL, josta kysymykset ladataan, suhteessa lataussivun URLiin."},
      };
    return pinfo;
  }

  // Omat metodit alkavat tst

  /**
   * Ladataan kysymystiedosto, luetaan siit kysymykset, rakennetaan niist
   * Kysymys-oliot ja tallennetaan ne Vectoriin (tarpeen mukaan kasvava taulukko).
   * Lopuksi nytetn ensimminen kysymys kyttjlle.
   * Tt metodia pitisi kutsua sovelman kynnistysvaiheessa (kuten init-metodin lopussa).
   */
  private void lataaKysymykset() {
    try {
      URL urli = new URL(this.getDocumentBase(),this.kysymysURL);
      BufferedReader reader = new BufferedReader(new InputStreamReader(urli.openStream()));
      String rivi;
      while((rivi=reader.readLine())!=null) {
        Kysymys k = new Kysymys(rivi,VAIHTOEHTO_MAARA);
        for(int n=0;n<VAIHTOEHTO_MAARA;n++) {
          rivi=reader.readLine();
          int pistearvo = Integer.parseInt(reader.readLine());
          k.lisaaVaihtoehto(rivi,pistearvo);
        }
        kysymykset.addElement(k);
      }
      reader.close();
      naytaKysymys(0);
    } catch(IOException ex) {
      ex.printStackTrace();
    }
  }
  /**
   * Nytt annetun numeron mukaisen kysymyksen kyttjlle.
   * @param kys Nytettvn kysymyksen numero (0 on ensimminen)
   */
  private void naytaKysymys(int kys) {
    // Haetaan haluttu kysymys Vectorista
    Kysymys k = (Kysymys)kysymykset.elementAt(kys);
    // Rakennetaan kysymysteksti, jonka eteen kysymyksen numero ja sijoitetaan nkyviin
    labelKysymys.setText((kys+1)+"/"+kysymykset.size()+": "+k.haeKysymys());
    // Asetetaan vastausvaihtoehtojen tekstit paikoilleen.
    for(int n=0;n<VAIHTOEHTO_MAARA;n++) vaihtoehdot[n].setLabel(k.haeVaihtoehto(n));
    // Tallennetaan, mik kysymys on nkyviss
    naytettyKysymys=kys;
    // Poistetaan valinnat Checkboxeista
    ryhma1.setSelectedCheckbox(null);
  }
  /**
   * Tallentaa tll hetkell nkyvn kysymykseen parametrina annetun
   * vastausvaihtoehdon numeron.
   * @param vastaus Vastauksen numero (0..3)
   */
  private void vastaa(int vastaus) {
    // Haetaan tll hetkell nkyv kysymys Vectorista.
    Kysymys k = (Kysymys)kysymykset.elementAt(naytettyKysymys);
    // Tallennetaan vastausvaihtoehdon numero.
    k.vastaa(vastaus);
  }
  /**
   * Nytt seuraavan kysymyksen.
   * @return Palauttaa false, jos ollaan jo viimeisess kysymyksess.
   */
  private boolean naytaSeuraava() {
    // Jos nytetn viimeist kysymyst, palautetaan false
    if (naytettyKysymys==kysymykset.size()-1) return false;
    // Nytetn seuraava kysymys
    naytaKysymys(naytettyKysymys+1);
    return true;
  }
  /**
   * Nytt lopputuloksen.
   * Tm versio vain nytt pisteet kysymyksen paikalla sammuttaa vastausvaihtoehdot.
   * Parannettu malli voisi nytt tuloksen erillisess ikkunassa.
   */
  private void naytaTulos() {
    int pisteet=0;
    for(int n=0;n<kysymykset.size();n++) {
      pisteet+=((Kysymys)kysymykset.elementAt(n)).haePisteet();
    }
    labelKysymys.setText("Sait " + pisteet + " pistett!");
    for(int n=0;n<VAIHTOEHTO_MAARA;n++) vaihtoehdot[n].setEnabled(false);
  }
  /**
   * Tm metodi on luotu Designerin tapahtumanksittelyn kautta. Metodia kutsutaan,
   * kun Vastaa-nappia painetaan. Metodin sislt on itse kirjoitettu ja siin
   * tarkistetaan, mit Checkboxia on painettu, vastaus tallennetaan ja sitten
   * joko nytetn seuraava kysymys tai (viimeisess oltaessa) nytetn tulos.
   */
  void buttonVastaa_actionPerformed(ActionEvent e) {
    for(int n=0;n<VAIHTOEHTO_MAARA;n++) {
      if (ryhma1.getSelectedCheckbox()==vaihtoehdot[n]) {
        vastaa(n);
        if (!naytaSeuraava()) {
          naytaTulos();
          buttonVastaa.setEnabled(false);
        }
        return;
      }
    }
  }
}